/* eslint-disable no-console */
import React from 'react';
import { action } from '@storybook/addon-actions';
import { withKnobs, text } from '@storybook/addon-knobs';
import OverflowMenu from '../OverflowMenu';
import OverflowMenuItem from '../OverflowMenuItem';
import Button from '../Button';
import Link from '../Link';
import Card from './Card';
import CardFooter from '../CardFooter';
import CardContent from '../CardContent';
import CardContentItem from '../CardContentItem';
import mdx from './Card.mdx';
var props = {
  default: function _default() {
    return {
      onClick: action('onClick'),
      onFocus: action('onFocus'),
      className: text('class name', 'some-class'),
      description: text('description', 'description')
    };
  }
};
export default {
  title: 'RocketPatterns/Card',
  decorators: [withKnobs],
  parameters: {
    component: Card,
    docs: {
      page: mdx
    }
  }
};
export var Default = function Default() {
  return /*#__PURE__*/React.createElement(Card, props.default(), /*#__PURE__*/React.createElement(CardContent, {
    cardTitle: "Card Name",
    cardInfo: ['Lorem ipsum sit amet, consectetur adipisicing elit, sed do eiusmod tempor']
    /* eslint-disable react/jsx-key, jsx-a11y/anchor-is-valid */
    ,
    cardLink: [/*#__PURE__*/React.createElement("a", {
      href: "#",
      className: "bx--link bx--card-footer__link"
    }, "Link")]
    /* eslint-enable react/jsx-key, jsx-a11y/anchor-is-valid */

  }, /*#__PURE__*/React.createElement(OverflowMenu, null, /*#__PURE__*/React.createElement(OverflowMenuItem, {
    itemText: "Stop App"
  }), /*#__PURE__*/React.createElement(OverflowMenuItem, {
    itemText: "Restart App"
  }), /*#__PURE__*/React.createElement(OverflowMenuItem, {
    itemText: "Rename App"
  }), /*#__PURE__*/React.createElement(OverflowMenuItem, {
    itemText: "Delete App",
    hasDivider: true
  }))), /*#__PURE__*/React.createElement(CardFooter, null, /*#__PURE__*/React.createElement(Button, {
    size: "small",
    kind: "primary",
    style: {
      width: 10 + '%'
    }
  }, "Button"), /*#__PURE__*/React.createElement(Link, {
    href: "#",
    className: "bx--card-footer__link"
  }, "Link")));
};
Default.story = {
  name: 'Card'
};
export var CustomItems = function CustomItems() {
  return /*#__PURE__*/React.createElement(Card, props.default(), /*#__PURE__*/React.createElement(CardContent, {
    cardTitle: "Card Name",
    cardInfo: ['Lorem ipsum sit amet, consectetur adipisicing elit, sed do eiusmod tempor']
    /* eslint-disable react/jsx-key, jsx-a11y/anchor-is-valid */
    ,
    cardLink: [/*#__PURE__*/React.createElement("a", {
      href: "#",
      className: "bx--link bx--card-footer__link"
    }, "Link")],
    cardContentItems: [/*#__PURE__*/React.createElement(CardContentItem, {
      info: 'Lorem ipsum sit amet, consectetur adipisicing elit, sed do eiusmod tempor',
      maxWidth: '10rem'
    })]
    /* eslint-enable react/jsx-key, jsx-a11y/anchor-is-valid */

  }, /*#__PURE__*/React.createElement(OverflowMenu, null, /*#__PURE__*/React.createElement(OverflowMenuItem, {
    itemText: "Stop App"
  }), /*#__PURE__*/React.createElement(OverflowMenuItem, {
    itemText: "Restart App"
  }), /*#__PURE__*/React.createElement(OverflowMenuItem, {
    itemText: "Rename App"
  }), /*#__PURE__*/React.createElement(OverflowMenuItem, {
    itemText: "Delete App",
    hasDivider: true
  }))), /*#__PURE__*/React.createElement(CardFooter, null, /*#__PURE__*/React.createElement(Button, {
    size: "small",
    kind: "primary",
    style: {
      width: 10 + '%'
    }
  }, "Button"), /*#__PURE__*/React.createElement(Link, {
    href: "#",
    className: "bx--card-footer__link"
  }, "Link")));
};
CustomItems.story = {
  name: 'Card With Custom Items'
};