"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports._Default = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _addonKnobs = require("@storybook/addon-knobs");

var _ButtonGroup = _interopRequireDefault(require("../ButtonGroup"));

var _OverflowMenuItem = _interopRequireDefault(require("../OverflowMenuItem"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var kinds = {
  'Primary button (primary)': 'primary',
  'Secondary button (secondary)': 'secondary',
  'Danger button (danger)': 'danger',
  'Ghost button (ghost)': 'ghost'
};
var sizes = {
  Default: 'default',
  Field: 'field',
  Small: 'small'
};
var props = {
  regular: function regular() {
    return {
      buttonLabel: (0, _addonKnobs.text)('Button Label', 'Button Label'),
      size: (0, _addonKnobs.select)('Button size (size)', sizes, 'default'),
      kind: (0, _addonKnobs.select)('Button kind (kind)', kinds, 'primary'),
      disabled: (0, _addonKnobs.boolean)('Disabled (disabled)', false)
    };
  }
};
var _default = {
  title: 'RocketPatterns/ButtonGroup',
  decorators: [_addonKnobs.withKnobs],
  parameters: {
    component: _ButtonGroup.default
  }
};
exports.default = _default;

var _Default = function _Default() {
  return /*#__PURE__*/_react.default.createElement(_ButtonGroup.default, props.regular(), /*#__PURE__*/_react.default.createElement(_OverflowMenuItem.default, {
    primaryFocus: true,
    itemText: 'Item 1'
  }), /*#__PURE__*/_react.default.createElement(_OverflowMenuItem.default, {
    itemText: 'Item 2'
  }), /*#__PURE__*/_react.default.createElement(_OverflowMenuItem.default, {
    itemText: 'Item 3'
  }));
};

exports._Default = _Default;